unit Math2;

interface

type
  TMatrix=array of array of double;

procedure Gauss(n:byte;a:TMatrix;var OutRes:array of double);
procedure StepOGI(n,m,r,s:integer;var Soure:TMatrix);
procedure Obratn(n,m:integer;var Source:TMatrix);
procedure MatrixProiz(na,ma,nb,mb:integer;a,b:TMatrix;var Dest:TMatrix);
procedure MatrixTranspon(na,ma:integer;a:TMatrix;var Dest:TMatrix);

implementation

procedure Gauss(n:byte;a:TMatrix;var OutRes:array of double);
var
  i,j,k:integer;
  r:double;
begin
  for k:=0 to n-1 do
  begin
    r:=a[k,k];
    for i:=0 to n-1 do
      for j:=0 to n do
        if not((i=k) or (j=k)) then a[i,j]:=(a[i,j]*r-a[i,k]*a[k,j])/r;
    for j:=0 to n do a[k,j]:=a[k,j]/r;
    for i:=0 to n-1 do a[i,k]:=0;
    a[k,k]:=1;
  end;
  for i:=0 to n-1 do OutRes[i]:=a[i,n];
end;

procedure StepOGI(n,m,r,s:integer;var Soure:TMatrix);
var
  raz:extended;
  i,j:integer;
begin
  raz:=Soure[r,s];
  for i:=0 to n-1 do
    for j:=0 to m-1 do
      if (i<>r) and (j<>s) then Soure[i,j]:=(raz*Soure[i,j]-Soure[i,s]*Soure[r,j]);
  for j:=0 to m-1 do Soure[r,j]:=-Soure[r,j];
  Soure[r,s]:=1;
  for i:=0 to n-1 do
    for j:=0 to m-1 do
      Soure[i,j]:=Soure[i,j]/raz;
end;

procedure Obratn(n,m:integer;var Source:TMatrix);
var
  i:byte;
begin
  for i:=0 to n-1 do StepOGI(n,m,i,i,Source);
end;

procedure MatrixProiz(na,ma,nb,mb:integer;a,b:TMatrix;var Dest:TMatrix);
var
  i,j,k,
  nc,mc:integer;
begin
  nc:=na;
  mc:=mb;
  for i:=0 to nc-1 do
    for j:=0 to mc-1 do
      Dest[i,j]:=0;
  for i:=0 to na-1 do
    for j:=0 to mb-1 do
      for k:=0 to ma-1 do
        Dest[i,j]:=Dest[i,j]+a[i,k]*b[k,j];
end;

procedure MatrixTranspon(na,ma:integer;a:TMatrix;var Dest:TMatrix);
var
  i,j:byte;
begin
  for i:=0 to na-1 do
    for j:=0 to ma-1 do
      Dest[j,i]:=a[i,j];
end;

end.
