unit OneSV;

interface

uses
  Math;


//    HomeNum  EndNum  InArray  OutArray
procedure CopyArray(var OutArray,InArray:array of double;HomeNum,EndNum:integer);

//////////////////

//     
procedure SwapValue(var Value1,Value2:double);

//    ( )
// FirstMin=True   , False- 
procedure SequencingArray(var InOutArray:array of double;FirstMin:boolean);

//     
procedure MinMaxArray(InArray:array of double;var Min,Max:double);

//      
procedure MinMaxOptimizeArray(InArray:array of double;var Min,Max:double);

//   
function NumberPartitionSelection(N:word):word;

//     InArray
//    (LeftBorder,RightBorder)
// Include=True -     False-
function NumberHitInterval(InArray:array of double;
                           LeftBorder,RightBorder:double;
                           Include:boolean):integer;

//     
procedure FrequencyArray(var OutArray:array of double;InArray:array of double);



implementation

////////////////////////
// ,    
////////////////////////

//     HomeNum  EndNum  InArray  OutArray
procedure CopyArray(var OutArray,InArray:array of double;HomeNum,EndNum:integer);
var i,n1,n2:integer;
begin
  if HomeNum=-1 then n1:=Low(InArray) else n1:=HomeNum;
  if EndNum=-1 then n2:=High(InArray) else n2:=EndNum;
  for i:=n1 to n2 do OutArray[i]:=InArray[i];
end;

        //////////////////////////
        //         //
        //////////////////////////

       {   }

//     
procedure SwapValue(var Value1,Value2:double);
var
  temp:double;
begin
  temp:=Value1;
  Value1:=Value2;
  Value2:=temp;
end;
                    {   }

//    ( )
// FirstMin=True   , False- 
procedure SequencingArray(var InOutArray:array of double;FirstMin:boolean);
var
  i,j:integer;
begin
  for i:=Low(InOutArray) to High(InOutArray) do
    for j:=Low(InOutArray) to High(InOutArray)-1 do
    begin
      if (InOutArray[j]<>InOutArray[j+1])
      then if InOutArray[j]>InOutArray[j+1]
           then begin
                  if FirstMin
                  then SwapValue(InOutArray[j],InOutArray[j+1])
                end
           else if not FirstMin
                then SwapValue(InOutArray[j],InOutArray[j+1]);
    end;
end;

//     
procedure MinMaxArray(InArray:array of double;var Min,Max:double);
var
  i:integer;
begin
  Min:=1e1000;
  Max:=-1e1000;
  for i:=Low(InArray) to High(InArray) do
  begin
    if InArray[i]>Max
    then Max:=InArray[i];
    if InArray[i]<Min
    then Min:=InArray[i];
  end;
end;

//      
procedure MinMaxOptimizeArray(InArray:array of double;var Min,Max:double);
begin
  Min:=InArray[Low(InArray)];
  Max:=InArray[High(InArray)];
  if Min>Max then SwapValue(Min,Max);
end;

//   
function NumberPartitionSelection(N:word):word;
begin
  NumberPartitionSelection:=round(1+3.22*Log10(N));
end;

//     InArray
//    (LeftBorder,RightBorder)
// Include=True -     False-
function NumberHitInterval(InArray:array of double;
                           LeftBorder,RightBorder:double;
                           Include:boolean):integer;
var
  i,n:integer;
begin
  n:=0;
  for i:=Low(InArray) to High(InArray) do
  begin
    if ((InArray[i]>LeftBorder) and (InArray[i]<RightBorder)) then inc(n);
    if (((InArray[i]=LeftBorder) or (InArray[i]=RightBorder)) and include) then inc(n);
  end;
  NumberHitInterval:=n;
end;

//     
procedure FrequencyArray(var OutArray:array of double;InArray:array of double);
var
  i,nArray,nStep:integer;
  Min,Max,step:double;
begin
  SequencingArray(InArray,True);
  MinMaxOptimizeArray(InArray,Min,Max);
  nArray:=Length(InArray);
  nStep:=NumberPartitionSelection(nArray);
  step:=(Max-Min)/nArray;
  i:=0;
  while i<=nStep-1 do
  begin
    OutArray[i]:=NumberHitInterval(InArray,InArray[Low(InArray)]+step*i,
                                   InArray[Low(InArray)]+step*(i+1),True)
                                   /nArray;
    inc(i);
  end;
end;

end.
