//    
//     
//      
//   ,  TStatistic
unit StatisticClass;
interface
uses
  Math,OneSV,Laws,evalcomp,
  Dialogs,SysUtils,
  Math2;
type
  //   double
  TVector = record
    x1,x2:double;
  end;

  TVectInt = record
    x1,x2:integer;
  end;

  //  
  TStudent = record
    Group  :string[15];         //  
    Surname:string[25];         //  
    Variant:integer   ;	        // 
    NumExp :integer;            //  
  end;

  //    
  TCriterion=record
    Xi2Pirson       :extended;				//   
    Romanovsky      :extended;				// 
    Kolmogorov      :extended;				// 
  end;

  //   
  TStatistic = class(TObject)
  public
    //    ,   
    fieldNumExp         :word;    				//  
    fieldarraySV      	:array of double;                       //   
    fieldarraySVSort  	:array of double;                       //      
    arrayStepFree       :array of integer;                      //    
  private
    fieldrangeSV       	:TVector;                               // min & max   ( )
    fieldNIntervals     :word;					//    (=1+3.322LgN)
    fieldStepInterval   :extended;				//   (     )
    fieldMx            	:extended;
    fieldDx             :extended;
    fieldCKO            :extended;
    fieldSkew           :extended;
    fieldKurtosis       :extended;
    fieldM3             :extended;
    fieldM4             :extended;
    fieldCriterion      :TCriterion;                            //    
    fieldLaw            :byte;                                  //    
    {
    1 :  ()
    2 :  
    3 : 
    4 :  () 
    5 : -
    6 : 
    7 :  ()
    8 :  
    9 :  
    }
    //      
  public
    function  funXi2Pirson(Law:byte;flagUnion:boolean):extended;                                //  Xi2    Low
    function  funRomanovsky(Xi2Pirson:extended;kDegreesFree:word):extended;   //   
    function  funKolmogorov(Law:byte;flagUnion:boolean):extended;                               //   
  private
    //       - 
    procedure RefreshIntervals;
    procedure RefreshCriterion;
    //  / 
    procedure SetNIntervals(value:word);
    function  GetInterval(index:integer):TVector;
    procedure SetInterval(index:integer;VectValue:TVector);
    function  GetAverageInterval(index:integer):extended;
    procedure SetAverageInterval(index:integer;Value:extended);
    function  GetFrequency(index:integer):word;
    procedure SetFrequency(index:integer;Value:word);
    function  GetRelativeFrequency(index:integer):extended;
    procedure SetRelativeFrequency(index:integer;Value:extended);
    function  GetDensityFrequency(index:integer):extended;
    procedure SetDensityFrequency(index:integer;Value:extended);
    function  GetDensityRelativeFrequency(index:integer):extended;
    procedure SetDensityRelativeFrequency(index:integer;Value:extended);
    function  GetFIntegral(index:integer):extended;
    procedure SetFIntegral(index:integer;Value:extended);
    function  GetCriterion(index:integer):TCriterion;
    procedure FillProizTabl;
  public
    //  
    DxIsp:extended;
    // ,    
    proizM1,
    proizM2,
    proizM3,
    proizM4,
    proizSkew,
    proizKurtosis,
    proizCentrM3,
    proizCentrM4,
    choiceAverage,
    choiceDx:extended;
    ProizTabl:array of array of integer;
    // 
    arrayIntervals:array of TVector;                               //   ,    
    arrayAverageIntervals:array of extended;                       //     (x1+x2)/2
    arrayFrequencies:array of word;				   //       
    arrayRelativeFrequencies:array of extended;		           //    ni/n
    arrayDensityFrequencies:array of extended;			   //    ni/h, .         
    arrayDensityRelativeFrequencies:array of extended;	   	   //     Wi/h, . Wi    
    arrayFIntegral:array of extended;				   //      
    arrayCriterion:array[0..8] of TCriterion;                      //      9  (  )
    arrayCentrX:array of extended;                                 //  X
    // 
    constructor Create(sv:array of double);            		   //   
    // 

    // 
    procedure SaveToFile(FileName:string);                         //     
       // Warning !!!
       //       ,        
    procedure FillCriterion;
       //       (index) 
    function  GetXi2Pirson(index:integer):extended;
    function  GetRomanovsky(index:integer):extended;
    function  GetKolmogorov(index:integer):extended;
       //    ,     ,   
    function  RunCriterion(index:integer):TCriterion;
    function  RunXi2Pirson(index:integer):extended;
    function  RunRomanovsky(index:integer):extended;
    function  RunKolmogorov(index:integer):extended;
    // 
    property NumExp:word           read fieldNumExp; 		   //  
    property NIntervals:word       read fieldNIntervals write SetNIntervals;
    property StepInterval:extended read fieldStepInterval;
    property Mx:extended        read fieldMx; 		 	   // . 
    property Dx:extended        read fieldDx;                      // 
    property CKO:extended       read fieldCKO;                 	   // 
    property M3:extended        read fieldM3;            	   //  3- 
    property M4:extended        read fieldM4;           	   //  4- 
    property Skew:extended      read fieldSkew;      	           // 
    property Kurtosis:extended  read fieldKurtosis;      	   // 
    property Law:byte           read fieldLaw;                     //    
    property Intervals[Index:integer]:TVector	read GetInterval   write SetInterval; //   ,     ( arrayStatIntervals)
    property AverageIntervals[Index:integer]:extended read GetAverageInterval write SetAverageInterval;
    property Frequencies[Index:integer]:word 	read GetFrequency  write SetFrequency;
    property RelativeFrequencies[Index:integer]:extended  read GetRelativeFrequency   write SetRelativeFrequency;
    property DensityFrequencies[Index:integer]:extended	read GetDensityFrequency  write SetDensityFrequency;
    property DensityRelativeFrequencies[Index:integer]:extended	read GetDensityRelativeFrequency  write SetDensityRelativeFrequency;
    property FIntegral[Index:integer]:extended read GetFIntegral write SetFIntegral;
    property Criterion[Index:integer]:TCriterion read GetCriterion;
  end;

  TFunConverter = class(TStatistic)
    // 
    constructor Create(sv:array of double;FunConverter:string);                //   
  end;

  TStatistic2 = class(TObject)
  public
    SV_NumExp:integer;
    SV_X,SV_Y:TStatistic;
    arraySV_X,                                                  // X
    arraySV_Y,                                                  // Y
    arraySV_XSort,                                              // Sort X
    arraySV_YSort,                                              // Sort Y
    arraySV_YSortX:array of double;                             // Y-   X
    SumX,SumX2,SumX3,SumX4,
    SumY,SumY2,SumY3,SumY4,
    SumXY,
    SumX2Y,
    SumXY2:extended;                         // 
    NStepReg:integer;                        //       
    CorTabl:array of array of integer;       //  
    Kxy,Rxy:extended;
    //    4- 
    poleposC:TVectInt;
    poleCX,poleCY :extended;
    poleU,poleV,
    poleU2,poleV2,
    poleSigmaU,poleSigmaV,
    poleRv:extended;
    Pole4:array of array of TVectInt;         //   4- 
    procedure FillPole4;
    // 
    constructor Create(sv1,sv2:array of double);                //   
  end;

  function ArraySumPower(Source:array of double;pow:extended):extended;
  function ArraySumPowerLg(Source:array of double;pow:extended):extended;

implementation

//////////////
// TStatistic2
//////////////

constructor TStatistic2.Create(sv1,sv2:array of double);
var
  i,j,jj,k:integer;
  x1,x2,y1,y2,v:double;
  max:extended;
begin
  SetLength(arraySV_X,Length(sv1));
  SetLength(arraySV_Y,Length(sv1));
  CopyArray(arraySV_X,sv1,-1,-1);
  CopyArray(arraySV_Y,sv2,-1,-1);
  SV_X:=TStatistic.Create(sv1);
  SV_Y:=TStatistic.Create(sv2);
  SV_NumExp:=SV_X.fieldNumExp;
  //   
  SumX:=Sum(arraySV_X);
  SumY:=Sum(arraySV_Y);
  SumX2:=SumOfSquares(arraySV_X);
  SumY2:=SumOfSquares(arraySV_Y);
  NStepReg:=50;
  for i:=0 to SV_NumExp-1 do
  begin
    SumX3:=SumX3+arraySV_X[i]*arraySV_X[i]*arraySV_X[i];
    SumY3:=SumY3+arraySV_Y[i]*arraySV_Y[i]*arraySV_Y[i];
    SumX4:=SumX4+arraySV_X[i]*arraySV_X[i]*arraySV_X[i]*arraySV_X[i];
    SumY4:=SumY4+arraySV_Y[i]*arraySV_Y[i]*arraySV_Y[i]*arraySV_Y[i];
    SumXY:=SumXY+arraySV_X[i]*arraySV_Y[i];
    SumX2Y:=SumX2Y+arraySV_X[i]*arraySV_X[i]*arraySV_Y[i];
    SumXY2:=SumXY2+arraySV_Y[i]*arraySV_Y[i]*arraySV_X[i];
  end;
  SetLength(arraySV_XSort,Length(sv1));
  CopyArray(arraySV_XSort,SV_X.fieldarraySVSort,-1,-1);
  SetLength(arraySV_YSort,Length(sv1));
  CopyArray(arraySV_YSort,SV_Y.fieldarraySVSort,-1,-1);
  SetLength(arraySV_YSortX,Length(sv1));
  for i:=0 to SV_X.fieldNumExp-1 do
  begin
    v:=arraySV_XSort[i];
    for j:=0 to SV_X.fieldNumExp-1 do
    begin
      if v=arraySV_X[j]
      then begin
             arraySV_YSortX[i]:=arraySV_Y[j];
             break;
           end;
    end;
  end;
  // . 
  SetLength(CorTabl,SV_Y.NIntervals+1,SV_X.NIntervals+1);
  for i:=0 to SV_Y.NIntervals-1 do
  begin
    for j:=0 to SV_X.NIntervals-1 do
    begin
      x1:=SV_X.Intervals[j].x1;
      x2:=SV_X.Intervals[j].x2;
      y1:=SV_Y.Intervals[i].x1;
      y2:=SV_Y.Intervals[i].x2;
      for jj:=0 to SV_NumExp do
      begin
        if((arraySV_X[jj]>=x1) and
           (arraySV_X[jj]<=x2) and
           (arraySV_Y[jj]>=y1) and
           (arraySV_Y[jj]<=y2)) then CorTabl[i,j]:=CorTabl[i,j]+1;
      end;
    end;
  end;
  // Sum Row
  for i:=0 to SV_Y.NIntervals-1 do
  begin
    k:=0;
    for j:=0 to SV_X.NIntervals-1 do k:=k+CorTabl[i,j];
    CorTabl[i,SV_X.NIntervals]:=k;
  end;
  // Sum Col
  for j:=0 to SV_Y.NIntervals-1 do
  begin
    k:=0;
    for i:=0 to SV_X.NIntervals-1 do k:=k+CorTabl[i,j];
    CorTabl[SV_Y.NIntervals,j]:=k;
  end;
  k:=0;
  for i:=0 to SV_X.NIntervals-1 do
    k:=k+CorTabl[i,SV_X.NIntervals]+CorTabl[SV_X.NIntervals,i];
  CorTabl[SV_Y.NIntervals,SV_X.NIntervals]:=k div 2;
  //     . 4- 
  max:=0;
  for i:=0 to SV_Y.NIntervals-1 do
    for j:=0 to SV_X.NIntervals-1 do
    if CorTabl[i,j]>max
    then begin
           max:=CorTabl[i,j];
           poleposC.x1:=i;
           poleposC.x2:=j;
           poleCX:=SV_X.arrayAverageIntervals[j];
           poleCY:=SV_Y.arrayAverageIntervals[i];
         end;
  //   4- 
  FillPole4;
  //  Kxy  Rxy
  Kxy:=0;
  for i:=0 to SV_X.fieldNumExp-1 do
  //  for j:=0 to SV_Y.fieldNumExp-1 do
      Kxy:=Kxy+(arraySV_X[i]-SV_X.Mx)*(arraySV_Y[i]-SV_Y.Mx);
  Rxy:=Kxy/(SV_X.CKO*SV_Y.CKO);
end;

//  4- 
//  
// 0,0  0,NInt+1  0,NInt+2  NInt+1,0  NInt+2,0
procedure TStatistic2.FillPole4;
var
  s:extended;
  max,i,j:integer;
begin
  SetLength(Pole4,SV_Y.NIntervals+3,SV_X.NIntervals+3);
  for i:=0 to SV_Y.NIntervals+2 do
    for j:=0 to SV_X.NIntervals+2 do
    begin
      Pole4[i,j].x1:=0;
      Pole4[i,j].x2:=0;
    end;
  //^^^   max
  for i:=1 to SV_Y.NIntervals do Pole4[i,0].x1:=i-poleposC.x1-1;
  for j:=1 to SV_X.NIntervals do Pole4[0,j].x1:=j-poleposC.x2-1;
  //^^^  U V
  for i:=1 to SV_Y.NIntervals do
  begin
    for j:=1 to SV_X.NIntervals do
    begin
      Pole4[i,j].x1:=CorTabl[i-1,j-1];
      Pole4[i,j].x2:=Pole4[i,0].x1*Pole4[0,j].x1;
      if (i<poleposC.x1) and (j<poleposC.x2)
      then begin
             Pole4[i,SV_X.NIntervals+1].x1:=
             Pole4[i,SV_X.NIntervals+1].x1+Pole4[i,j].x1*Pole4[i,j].x2;
             Pole4[SV_Y.NIntervals+1,j].x1:=
             Pole4[SV_Y.NIntervals+1,j].x1+Pole4[i,j].x1*Pole4[i,j].x2;
             inc(Pole4[SV_Y.NIntervals+1,SV_X.NIntervals+1].x1,Pole4[i,j].x1*Pole4[i,j].x2);
           end;
      if (i<poleposC.x1) and (j>poleposC.x2)
      then begin
             Pole4[i,SV_X.NIntervals+2].x1:=
             Pole4[i,SV_X.NIntervals+2].x1+Pole4[i,j].x1*Pole4[i,j].x2;
             Pole4[SV_Y.NIntervals+1,j].x1:=
             Pole4[SV_Y.NIntervals+1,j].x1+Pole4[i,j].x1*Pole4[i,j].x2;
             inc(Pole4[SV_Y.NIntervals+1,SV_X.NIntervals+2].x1,Pole4[i,j].x1*Pole4[i,j].x2);
           end;
      if (i>poleposC.x1) and (j<poleposC.x2)
      then begin
             Pole4[i,SV_X.NIntervals+1].x1:=
             Pole4[i,SV_X.NIntervals+1].x1+Pole4[i,j].x1*Pole4[i,j].x2;
             Pole4[SV_Y.NIntervals+2,j].x1:=
             Pole4[SV_Y.NIntervals+2,j].x1+Pole4[i,j].x1*Pole4[i,j].x2;
             inc(Pole4[SV_Y.NIntervals+2,SV_X.NIntervals+1].x1,Pole4[i,j].x1*Pole4[i,j].x2);
           end;
      if (i>poleposC.x1) and (j>poleposC.x2)
      then begin
             Pole4[i,SV_X.NIntervals+2].x1:=
             Pole4[i,SV_X.NIntervals+2].x1+Pole4[i,j].x1*Pole4[i,j].x2;
             Pole4[SV_Y.NIntervals+2,j].x1:=
             Pole4[SV_Y.NIntervals+2,j].x1+Pole4[i,j].x1*Pole4[i,j].x2;
             inc(Pole4[SV_Y.NIntervals+2,SV_X.NIntervals+2].x1,Pole4[i,j].x1*Pole4[i,j].x2);
           end;
    end;
  end;
  s:=0;
  for j:=1 to SV_X.fieldNIntervals do s:=s+CorTabl[SV_Y.fieldNIntervals,j-1]*Pole4[0,j].x1;
  poleU:=s/SV_NumExp;
  s:=0;
  for i:=1 to SV_Y.fieldNIntervals do s:=s+CorTabl[i-1,SV_Y.fieldNIntervals]*Pole4[i,0].x1;
  poleV:=s/SV_NumExp;
  s:=0;
  for j:=1 to SV_X.fieldNIntervals do s:=s+CorTabl[SV_Y.fieldNIntervals,j-1]*sqr(Pole4[0,j].x1);
  poleU2:=s/SV_NumExp;
  s:=0;
  for i:=1 to SV_Y.fieldNIntervals do s:=s+CorTabl[i-1,SV_Y.fieldNIntervals]*sqr(Pole4[i,0].x1);
  poleV2:=s/SV_NumExp;
  poleSigmaU:=sqrt(poleU2-sqr(poleU));
  poleSigmaV:=sqrt(poleV2-sqr(poleV));
  poleRv:=(pole4[SV_Y.NIntervals+1,SV_X.NIntervals+1].x1+
           pole4[SV_Y.NIntervals+1,SV_X.NIntervals+2].x1+
           pole4[SV_Y.NIntervals+2,SV_X.NIntervals+1].x1+
           pole4[SV_Y.NIntervals+2,SV_X.NIntervals+2].x1-
           SV_NumExp*poleU*poleV)/
          (SV_NumExp*poleSigmaU*poleSigmaV);
end;

function ArraySumPower(Source:array of double;pow:extended):extended;
var
  s:extended;
  i:integer;
  flag:boolean;
begin
  flag:=false;
  Result:=0;
  for i:=Low(Source) to High(Source) do
  begin
    s:=power(Source[i],pow);
    try
      Result:=Result+s;
    except
      if not flag then ShowMessage('   ');
      flag:=true;
    end;
  end;
end;

function ArraySumPowerLg(Source:array of double;pow:extended):extended;
var
  s:extended;
  i:integer;
  flag:boolean;
begin
  flag:=false;
  Result:=0;
  for i:=Low(Source) to High(Source) do
  begin
    s:=power(Log10(Source[i]),pow);
    try
      Result:=Result+s;
    except
      if not flag then ShowMessage('   ');
      flag:=true;
    end;
  end;

end;

//////////////
// TStatistic
//////////////

constructor TStatistic.Create(sv:array of double);
var
  i:integer;
begin
  inherited Create;
  fieldNumExp:=Length(sv);                    // fieldNumExp it's OK
  SetLength(fieldarraySV,fieldNumExp);
  CopyArray(fieldarraySV,sv,0,fieldNumExp-1); // fieldarraySV it's OK
  SetLength(fieldarraySVSort,fieldNumExp);
  CopyArray(fieldarraySVSort,fieldarraySV,0,fieldNumExp-1);
  SequencingArray(fieldarraySVSort,true);     // fieldarraySVSort it's OK
  MinMaxOptimizeArray(fieldarraySVSort,fieldrangeSV.x1,fieldrangeSV.x2); // rangeSV it's OK
  fieldNIntervals:=NumberPartitionSelection(fieldNumExp);    //  
  RefreshIntervals;
  MomentSkewKurtosis(fieldarraySVSort,fieldMx,fieldDx,fieldM3,fieldM4,fieldSkew,fieldKurtosis); //  Mx,Dx,M3,M4,Skew,Kurtosis
  DxIsp:=fieldDx*fieldNumExp/(fieldNumExp-1);// . 
  fieldCKO:=sqrt(fieldDx);                  // CKO
  SetLength(arrayCentrX,fieldNumExp);
  for i:=0 to fieldNumExp-1 do arrayCentrX[i]:=fieldarraySVSort[i]-fieldMx;
end;

procedure TStatistic.RefreshIntervals;
var i,j:word;
begin
  fieldStepInterval:=abs(fieldrangeSV.x2-fieldrangeSV.x1)/fieldNIntervals; //  
  //    
  SetLength(arrayIntervals,fieldNIntervals);
  SetLength(arrayAverageIntervals,fieldNIntervals);
  for i:=0 to fieldNIntervals-1 do
  begin
    arrayIntervals[i].x1:=fieldrangeSV.x1+i*fieldStepInterval;
    arrayIntervals[i].x2:=fieldrangeSV.x1+(i+1)*fieldStepInterval;
    arrayAverageIntervals[i]:=(arrayIntervals[i].x1+arrayIntervals[i].x2)/2;
    Intervals[i]:=arrayIntervals[i];
  end;   //   OK
  //   (    )
  arrayFrequencies:=NIL;
  SetLength(arrayFrequencies,fieldNIntervals);
  i:=0;
  for j:=0 to fieldNumExp-1 do
  begin
    if fieldarraySVSort[j]<=arrayIntervals[i].x2
    then Frequencies[i]:=Frequencies[i]+1
    else begin
           inc(i);
           Frequencies[i]:=Frequencies[i]+1;
         end;
  end;
  //     
  SetLength(arrayRelativeFrequencies,fieldNIntervals);
  for i:=0 to fieldNIntervals-1 do RelativeFrequencies[i]:=Frequencies[i]/fieldNumExp;
  //    (     /   )
  SetLength(arrayDensityFrequencies,fieldNIntervals);
  for i:=0 to fieldNIntervals-1 do DensityFrequencies[i]:=Frequencies[i]/fieldStepInterval;
  //    (     /   )
  SetLength(arrayDensityRelativeFrequencies,fieldNIntervals);
  for i:=0 to fieldNIntervals-1 do DensityRelativeFrequencies[i]:=RelativeFrequencies[i]/fieldStepInterval;
  //     
  SetLength(arrayFIntegral,fieldNIntervals+1);
  arrayFIntegral[0]:=0;
  for i:=1 to fieldNIntervals do arrayFIntegral[i]:=arrayFIntegral[i-1]+RelativeFrequencies[i-1];
  //  .    1
  ///!!!
  SetLength(arrayStepFree,10);
  arrayStepFree[1]:=fieldNIntervals-3;
  arrayStepFree[2]:=fieldNIntervals-3;
  arrayStepFree[3]:=fieldNIntervals-3;
  arrayStepFree[4]:=fieldNIntervals-2;
  arrayStepFree[5]:=fieldNIntervals-3;
  arrayStepFree[6]:=fieldNIntervals-3;
  arrayStepFree[7]:=fieldNIntervals-3;
  arrayStepFree[8]:=fieldNIntervals-2;
  arrayStepFree[9]:=fieldNIntervals-3;
  //    
  FillProizTabl;
end;

//         
procedure TStatistic.FillProizTabl;
var
  max:extended;
  nmax,i:integer;
begin
  SetLength(ProizTabl,NIntervals+1,6);
  max:=0;
  for i:=0 to NIntervals-1 do
    if arrayFrequencies[i]>max
    then begin
           max:=arrayFrequencies[i];
           nmax:=i;
         end;
  //^^^   max  
  ProizTabl[NIntervals,1]:=0;
  ProizTabl[NIntervals,2]:=0;
  ProizTabl[NIntervals,3]:=0;
  ProizTabl[NIntervals,4]:=0;
  ProizTabl[NIntervals,5]:=0;
  for i:=0 to NIntervals-1 do
  begin
    ProizTabl[i,0]:=i-nmax;
    ProizTabl[i,1]:=arrayFrequencies[i]*ProizTabl[i,0];
    ProizTabl[i,2]:=arrayFrequencies[i]*sqr(ProizTabl[i,0]);
    ProizTabl[i,3]:=round(arrayFrequencies[i]*power(ProizTabl[i,0],3));
    ProizTabl[i,4]:=round(arrayFrequencies[i]*power(ProizTabl[i,0],4));
    ProizTabl[i,5]:=round(arrayFrequencies[i]*power(ProizTabl[i,0]+1,4));
    ProizTabl[NIntervals,1]:=ProizTabl[NIntervals,1]+ProizTabl[i,1];
    ProizTabl[NIntervals,2]:=ProizTabl[NIntervals,2]+ProizTabl[i,2];
    ProizTabl[NIntervals,3]:=ProizTabl[NIntervals,3]+ProizTabl[i,3];
    ProizTabl[NIntervals,4]:=ProizTabl[NIntervals,4]+ProizTabl[i,4];
    ProizTabl[NIntervals,5]:=ProizTabl[NIntervals,5]+ProizTabl[i,5];
  end;
  proizM1:=ProizTabl[NIntervals,1]/fieldNumExp;
  proizM2:=ProizTabl[NIntervals,2]/fieldNumExp;
  proizM3:=ProizTabl[NIntervals,3]/fieldNumExp;
  proizM4:=ProizTabl[NIntervals,4]/fieldNumExp;
  proizCentrM3:=(proizM3-3*proizM1*proizM2+2*power(proizM1,3))*power(fieldStepInterval,3);
  proizCentrM4:=(proizM4-4*proizM1*proizM3+6*sqr(proizM1)*proizM2-3*power(proizM1,4))*power(fieldStepInterval,4);
  choiceAverage:=proizM1*fieldStepInterval+arrayAverageIntervals[nmax];
  choiceDx:=(proizM2-sqr(proizM1))*sqr(fieldStepInterval);
  proizSkew:=proizCentrM3/power(choiceDx,3);
  proizKurtosis:=proizCentrM4/power(choiceDx,4);
end;

procedure TStatistic.RefreshCriterion;
var i:byte;
begin
 {
 for i:=0 to 8 do
  begin
    arrayCriterion[i].Xi2Pirson:=funXi2Pirson(i+1);
    arrayCriterion[i].Romanovsky:=funRomanovsky(arrayCriterion[i].Xi2Pirson,5);
    arrayCriterion[i].Kolmogorov:=funKolmogorov(i+1);
  end;
 }
end;

procedure TStatistic.SaveToFile(FileName:string);
var
  f:TextFile;
  i:integer;
begin
  AssignFile(f,FileName);
  rewrite(f);
  writeln(f,'   = ':20,fieldNumExp);
  writeln(f,' ');
  for i:=0 to fieldNumExp-1 do writeln(f,fieldarraySV[i]:10:5);
  writeln(f,'  ');
  for i:=0 to fieldNumExp-1 do writeln(f,fieldarraySVSort[i]:10:5);
  writeln(f,'   = ',fieldrangeSV.x1:10:5,fieldrangeSV.x2:10:5);
  writeln(f,'     = ',fieldNIntervals);
  writeln(f,'   = ',fieldStepInterval:10:5);
  writeln(f,'  ');
  for i:=0 to fieldNIntervals-1 do writeln(f,arrayIntervals[i].x1:10:5,arrayIntervals[i].x2:10:5);
  writeln(f,'  ');
  for i:=0 to fieldNIntervals-1 do writeln(f,arrayAverageIntervals[i]:10:5);
  writeln(f,'  ');
  for i:=0 to fieldNIntervals-1 do writeln(f,arrayFrequencies[i]);
  writeln(f,'    ()');
  for i:=0 to fieldNIntervals-1 do writeln(f,arrayRelativeFrequencies[i]:10:5);
  writeln(f,'  F(x)');
  for i:=0 to fieldNIntervals do writeln(f,arrayFIntegral[i]:10:5);
  writeln(f,' .  = ':20,fieldMx:10:5);
  writeln(f,'  = ':20,fieldDx:10:5);
  writeln(f,'  = ':20,fieldCKO:10:5);
  writeln(f,'  M3 = ':20,fieldM3:10:5);
  writeln(f,'  M4 = ':20,fieldM4:10:5);
  writeln(f,'  = ':20,fieldSkew:10:5);
  writeln(f,'  = ':20,fieldKurtosis:10:5);
  CloseFile(f);
end;

procedure TStatistic.FillCriterion;
begin
  RefreshCriterion;
end;

function  TStatistic.GetXi2Pirson(index:integer):extended;
begin
  Result:=arrayCriterion[index-1].Xi2Pirson;
end;

function  TStatistic.GetRomanovsky(index:integer):extended;
begin
  Result:=arrayCriterion[index-1].Romanovsky;
end;

function  TStatistic.GetKolmogorov(index:integer):extended;
begin
  Result:=arrayCriterion[index-1].Kolmogorov;
end;

function  TStatistic.RunCriterion(index:integer):TCriterion;
begin
  Result.Xi2Pirson:=RunXi2Pirson(index);
  Result.Romanovsky:=RunRomanovsky(index);
  Result.Kolmogorov:=RunKolmogorov(index);
end;

function  TStatistic.RunXi2Pirson(index:integer):extended;
begin
  //Result:=funXi2Pirson(index);
end;

function  TStatistic.RunRomanovsky(index:integer):extended;
begin
  //Result:=funRomanovsky(RunXi2Pirson(index),5{???});
end;

function  TStatistic.RunKolmogorov(index:integer):extended;
begin
  //Result:=funKolmogorov(index);
end;

procedure TStatistic.SetNIntervals(value:word);
begin
  fieldNIntervals:=value;
  RefreshIntervals;
end;

function  TStatistic.GetInterval(index:integer):TVector;
begin
  Result:=arrayIntervals[index];
end;

procedure TStatistic.SetInterval(index:integer;VectValue:TVector);
begin
  arrayIntervals[index]:=VectValue;
end;

function  TStatistic.GetAverageInterval(index:integer):extended;
begin
  Result:=arrayAverageIntervals[index];
end;

procedure TStatistic.SetAverageInterval(index:integer;Value:extended);
begin
  arrayAverageIntervals[index]:=Value;
end;

function TStatistic.GetFrequency(index:integer):word;
begin
  Result:=arrayFrequencies[index];
end;

procedure TStatistic.SetFrequency(index:integer;Value:word);
begin
  arrayFrequencies[index]:=Value;
end;

function TStatistic.GetRelativeFrequency(index:integer):extended;
begin
  Result:=arrayRelativeFrequencies[index];
end;

procedure TStatistic.SetRelativeFrequency(index:integer;Value:extended);
begin
  arrayRelativeFrequencies[index]:=Value;
end;

function TStatistic.GetDensityFrequency(index:integer):extended;
begin
  Result:=arrayDensityFrequencies[index];
end;

procedure TStatistic.SetDensityFrequency(index:integer;Value:extended);
begin
  arrayDensityFrequencies[index]:=Value;
end;

function TStatistic.GetDensityRelativeFrequency(index:integer):extended;
begin
  Result:=arrayDensityRelativeFrequencies[index];
end;

procedure TStatistic.SetDensityRelativeFrequency(index:integer;Value:extended);
begin
  arrayDensityRelativeFrequencies[index]:=Value;
end;

function TStatistic.GetFIntegral(index:integer):extended;
begin
  Result:=arrayFIntegral[index];
end;

procedure TStatistic.SetFIntegral(index:integer;Value:extended);
begin
  arrayFIntegral[index]:=Value;
end;

function TStatistic.GetCriterion(index:integer):TCriterion;
begin
  Result:=arrayCriterion[index];
end;

//   Xi2    Low
function TStatistic.funXi2Pirson(Law:byte;flagUnion:boolean):extended;
var
  i,
  n,NewIntervals:integer;
  pTheor,Xi2:extended;
  NewarrayIntervals:array of TVector;
  NewarrayRelativeFrequencies:array of extended;
begin
  if flagUnion
  then begin
          SetLength(NewarrayIntervals,fieldNIntervals);
          SetLength(NewarrayRelativeFrequencies,fieldNIntervals);
          NewIntervals:=fieldNIntervals;
          //   
          n:=0;
          for i:=Low(arrayIntervals) to High(arrayIntervals) do
          begin
            if arrayFrequencies[i]<5
            then begin
                   if i=0 then continue;
                   NewIntervals:=NewIntervals-1;
                   NewarrayIntervals[n-1].x2:=arrayIntervals[i].x2;
                   NewarrayRelativeFrequencies[n-1]:=
                     NewarrayRelativeFrequencies[n-1]+arrayRelativeFrequencies[i];
                 end
            else begin
                   NewarrayIntervals[n]:=arrayIntervals[n];
                   NewarrayRelativeFrequencies[n]:=arrayRelativeFrequencies[n];
                   n:=n+1;
                 end;
          end;
          // ^^^  
          Xi2:=0;
          for i:=Low(NewarrayIntervals) to NewIntervals-1 do
          begin
            pTheor:=IntTabl[Law](NewarrayIntervals[i].x2,fieldMx,fieldDx)-
                IntTabl[Law](NewarrayIntervals[i].x1,fieldMx,fieldDx);
            if pTheor=0 then pTheor:=0.00001;
           Xi2:=Xi2+abs(sqr(NewarrayRelativeFrequencies[i]-pTheor)/pTheor);
          end;
          NewarrayIntervals:=NIL;
          NewarrayRelativeFrequencies:=NIL;
          Result:=fieldNumExp*Xi2;
       end
  else begin
          Xi2:=0;
          for i:=Low(arrayIntervals) to High(arrayIntervals) do
          begin
            pTheor:=IntTabl[Law](arrayIntervals[i].x2,fieldMx,fieldDx)-
                IntTabl[Law](arrayIntervals[i].x1,fieldMx,fieldDx);
            if pTheor=0 then pTheor:=0.00001;
           Xi2:=Xi2+abs(sqr(arrayRelativeFrequencies[i]-pTheor)/pTheor);
          end;
          Result:=fieldNumExp*Xi2;
       end;
end;

//    
function TStatistic.funRomanovsky(Xi2Pirson:extended;kDegreesFree:word):extended;
begin
  Result:=(Xi2Pirson-kDegreesFree)/sqrt(2*kDegreesFree);
end;

//    
function TStatistic.funKolmogorov(Law:byte;flagUnion:boolean):extended;
var
  d:array of double;
  pTheor:extended;
  i:integer;
  n,NewIntervals:integer;
  NewarrayIntervals:array of TVector;
  NewarrayFIntegral:array of extended;
begin
  if flagUnion
  then begin
          SetLength(NewarrayIntervals,fieldNIntervals);
          SetLength(NewarrayFIntegral,fieldNIntervals);
          NewIntervals:=fieldNIntervals;
          //   
          n:=0;
          for i:=Low(arrayIntervals) to High(arrayIntervals) do
          begin
            if arrayFrequencies[i]<5
            then begin
                   if i=0 then continue;
                   NewIntervals:=NewIntervals-1;
                   NewarrayIntervals[n-1].x2:=arrayIntervals[i].x2;
                   NewarrayFIntegral[n-1]:=
                     NewarrayFIntegral[n-1]+arrayFIntegral[i];
                 end
            else begin
                   NewarrayIntervals[n]:=arrayIntervals[n];
                   NewarrayFIntegral[n]:=arrayFIntegral[n];
                   n:=n+1;
                 end;
          end;
          // ^^^  
          SetLength(d,fieldNIntervals);
          for i:=Low(NewarrayIntervals) to NewIntervals-1 do
          begin
            pTheor:=IntTabl[Law](NewarrayIntervals[i].x1,fieldMx,fieldDx);
            d[i]:=abs(NewarrayFIntegral[i]-pTheor);
          end;
          NewarrayIntervals:=NIL;
          NewarrayFIntegral:=NIL;
          Result:=sqrt(fieldNumExp)*MaxValue(d);
          d:=NIL;
       end
  else begin
         SetLength(d,fieldNIntervals);
         for i:=Low(arrayIntervals) to High(arrayIntervals) do
         begin
           pTheor:=IntTabl[Law](arrayIntervals[i].x1,fieldMx,fieldDx);
           d[i]:=abs(arrayFIntegral[i]-pTheor);
         end;
         Result:=sqrt(fieldNumExp)*MaxValue(d);
         d:=NIL;
       end;  
end;

///////////////////
// TFunConverter
///////////////////

constructor TFunConverter.Create(sv:array of double;FunConverter:string);
var
  calc: EVALVEC ;   //(evalvec -   ,  evalcomp)
  i:integer;
begin
  for i:=Low(sv) to High(sv) do
  begin
    try
      new (calc,init(FunConverter));   //(  )
      sv[i]:=calc^.eval1d(sv[i]);
    finally
      dispose(calc,done);              //(  )
    end;
  end;
  inherited Create(sv);
end;

end.
